// 2007-08-10

// 1.0x-a: 2007-08-02 added styleContainer,styleHide,styleShow

////////////////////////////////////////////////////////////////
// _fss.tag
////////////////////////////////////////////////////////////////
//_fss.tag = function (styleBody,styleSilhouette) {
_fss.tag = function (styleBody,styleSilhouette,styleContainer,styleHide,styleShow) {

	if (styleBody) this.styleBody = styleBody;
	if (styleSilhouette) this.styleSilhouette = styleSilhouette;
	if (styleContainer) this.styleContainer = styleContainer;
	if (styleHide) this.styleHide = styleHide;
	if (styleShow) this.styleShow = styleShow

	this.hide = function () {
//		this._tagContainer.style.visibility = 'hidden';
		_fss.setStyleSheetData(this._tagContainer,this.styleHide);
	};

	this._tagContainer = document.createElement('div');
//	this._tagContainer.style.position = 'absolute';
	_fss.setStyleSheetData(this._tagContainer,this.styleContainer);

	this._tagBody = document.createElement('div');
	_fss.setStyleSheetData(this._tagBody,this.styleBody);
	this._tagBody.style.position = 'absolute';

	this._tagSilhouette = document.createElement('div');
	_fss.setStyleSheetData(this._tagSilhouette,this.styleSilhouette);
	this._tagSilhouette.style.position = 'absolute';

	this._tagContainer.appendChild(this._tagSilhouette);
	this._tagContainer.appendChild(this._tagBody);

	this.hide();
	document.body.appendChild(this._tagContainer);

	this.show = function (message,top,left) {
		// top and left in px from document.body

		this._tagBody.appendChild(document.createTextNode(message));

		// top and left position is vp center if undefined
		var posTop = top;
		var posLeft = left;
		if (posTop == undefined || posLeft == undefined) {
			var vp = _fss.innerSize();
			var sc = _fss.scrollSize();

//alert('this._tagBody.offsetWidth:'+this._tagBody.offsetWidth);
			if (left == undefined)
				posLeft = sc.x + Math.round((vp.x - this._tagBody.offsetWidth)/2);
			if (top == undefined)
				posTop = sc.y + Math.round((vp.y - this._tagBody.offsetHeight)/2);
		}
		// set silhouette width and height from body
		this._tagSilhouette.style.width = this._tagBody.offsetWidth + 'px';
		this._tagSilhouette.style.height = this._tagBody.offsetHeight + 'px';

		this._tagContainer.style.top = posTop + 'px';
		this._tagContainer.style.left = posLeft + 'px';

//		this._tagContainer.style.visibility = 'visible';
		_fss.setStyleSheetData(this._tagContainer,this.styleShow);
//alert('this._tagSilhouette.style.margin:'+this._tagSilhouette.style.margin);
	};
};
//-fxref-// _fss.tag: _fss.setStyleSheetData _fss.innerSize _fss.scrollSize
//-fxref-// _fss.tag: _fss.styleSilhouette

// default silhouette style
_fss.tag.prototype.styleSilhouette = _fss.styleSilhouette;
_fss.tag.prototype.styleBody = _fss.styleBody;
_fss.tag.prototype.styleContainer = { position: 'absolute' };
_fss.tag.prototype.styleHide = { visibility: 'hidden' };
_fss.tag.prototype.styleShow = { visibility: 'visible' };
