<?php

#    dlgpl.php: a part of fss (Free Software Signature)
#    version 1.0 Copyright (C) 2006 Tagata Akira
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License as
#    published by the Free Software Foundation; either version 2 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
#    02110-1301 USA

$dlControl = 'dlGpl';
$gplControl = 'gpl';
$gplFileNameHardCodingRe = '/gpl\.txt$/';

function error($msg) {
	echo '<html>';
	echo '<head>';
	echo '</head>';
	echo '<body>';
	echo 'Error: '.$msg;
	echo '</body>';
	echo '</html>';
}

if (isset($_POST[$dlControl]) && $_POST[$dlControl] &&
	isset($_POST[$gplControl]) && $_POST[$gplControl] &&
	isset($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER'] &&
	isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST']) {

	$parsed_referrer = parse_url($_SERVER['HTTP_REFERER']);
	if ($parsed_referrer['host'] == $_SERVER['HTTP_HOST']) {

		$file = $_POST[$gplControl];
		if (substr($file,0,1) == '/') {
			$file = $_SERVER['DOCUMENT_ROOT'].$file;
		}
		$insecure_re = ',/\\.\\.?[^/],';
		if (is_file($file) && !preg_match($insecure_re,$file)
			&& (preg_match($gplFileNameHardCodingRe,$file))) {
			header('Content-type: text/plain');
			header('Content-Disposition: attachment; filename="'.basename($file).'"');
			readfile($file);
		}
		else {
			error(1);
		}
	}
	else {
		error(2);
	}
}
else {
	error(3);
}

?>
